//
//  AnimationScene.m
//  SpikeNav
//
//  Created by Robert Bridson on 24/06/09.
//  Released into the public domain.
//

#import "AnimationScene.h"
#include <OpenGL/gl.h>

extern const int Snx;
extern const float Sx[];
extern const int Sntri;
extern const int Stri[];
extern const float Snormal[];

@implementation AnimationScene

- (AnimationScene*) init
{
   [super init];
   radius=0;
   for(int i=0; i<Snx; ++i){
      float r=sqrt(Sx[3*i]*Sx[3*i]+Sx[3*i+1]*Sx[3*i+1]+Sx[3*i+2]*Sx[3*i+2]);
      if(r>radius) radius=r;
   }   
   return self;
}

- (void) renderWithLights: (BOOL)lighting
{
   glDepthMask(GL_TRUE);
   glDisable(GL_LIGHTING);
   glBegin(GL_TRIANGLES);
   for(int t=0; t<Sntri; ++t){
      int i=Stri[3*t+0], j=Stri[3*t+1], k=Stri[3*t+2];
      glColor3f(0.5*Snormal[3*t+0]+0.5, 0.5*Snormal[3*t+1]+0.5, 0.5*Snormal[3*t+2]+0.5);
      glVertex3fv(Sx+3*i);
      glVertex3fv(Sx+3*j);
      glVertex3fv(Sx+3*k);
   }
   glEnd();
   /*
   for(int i=0; i<5; ++i) for(int j=0; j<5; ++j){
      glPushMatrix();
      glTranslatef(2.6*(i-2), sin(i+j)*cos(i-j), 2.6*(j-2));
      glBegin(GL_QUADS);
      glColor3f(0, 0, 0);
      glVertex3f(-1, -1, -1);
      glVertex3f( 1, -1, -1);
      glVertex3f( 1, -1,  1);
      glVertex3f(-1, -1,  1);
      glColor3f(0.1, 0.1, 0.1);
      glVertex3f(-1, -1, -1);
      glVertex3f(-1,  1, -1);
      glVertex3f(-1,  1,  1);
      glVertex3f(-1, -1,  1);
      glColor3f(0.2, 0.2, 0.2);
      glVertex3f(-1, -1, -1);
      glVertex3f( 1, -1, -1);
      glVertex3f( 1,  1, -1);
      glVertex3f(-1,  1, -1);
      glColor3f(0.3, 0.3, 0.3);
      glVertex3f(-1,  1, -1);
      glVertex3f( 1,  1, -1);
      glVertex3f( 1,  1,  1);
      glVertex3f(-1,  1,  1);
      glColor3f(0.4, 0.4, 0.4);
      glVertex3f( 1, -1, -1);
      glVertex3f( 1,  1, -1);
      glVertex3f( 1,  1,  1);
      glVertex3f( 1, -1,  1);
      glColor3f(0.5, 0.5, 0.5);
      glVertex3f(-1, -1,  1);
      glVertex3f( 1, -1,  1);
      glVertex3f( 1,  1,  1);
      glVertex3f(-1,  1,  1);
      glEnd();
      glPopMatrix();
   }
   */
}

- (float) radius
{
   return radius;
}

@end
